/******************************************************************************/
/*                                                                            */
/*                               RAINE GAME LISTS                             */
/*                                                                            */
/******************************************************************************/

#include "raine.h"
#include "games.h"

char *company_name[] =
{
   "Unknown",
   "Bootleg",
   "Capcom",
   "Data East",
   "Irem",
   "Jaleco",
   "Konami",
   "Nichibutsu",
   "Sega",
   "SNK",
   "Taito",
   "Tecmo",
   "Toaplan",
   "Banpresto",
   "UPL",
   "Namco",
   "NTC",
   "Visco",
   "Face",
   "Seibu",
   "Sammy",
   "Video System",
   "Alpha Denshi",
   "Nazca",
   "Technos",
   "NMK",
   "Sunsoft",
   "Aicom",
   "Yumekobo",
   "Hudson Soft",
   "Tad",
   "Comad",
   "Seta",
   "Excellent System",
   "Kaneko",
   "Raizing",
   "Cave",
};

extern struct GAME_MAIN game_64th_street;
extern struct GAME_MAIN game_64th_street_japanese;
extern struct GAME_MAIN game_air_inferno;
extern struct GAME_MAIN game_american_horseshoes;
extern struct GAME_MAIN game_aqua_jack;
extern struct GAME_MAIN game_arabian_magic;
extern struct GAME_MAIN game_ark_area;
extern struct GAME_MAIN game_arkanoid_2_american;
extern struct GAME_MAIN game_arkanoid_2_japanese;
extern struct GAME_MAIN game_arkanoid_2_rev_of_doh;
extern struct GAME_MAIN game_arkanoid_returns;
extern struct GAME_MAIN game_armed_formation;
extern struct GAME_MAIN game_ashura_blaster;
extern struct GAME_MAIN game_ashura_blaster_us;
extern struct GAME_MAIN game_astyanax;
extern struct GAME_MAIN game_asuka_and_asuka;
extern struct GAME_MAIN game_atomic_robo_kid;
extern struct GAME_MAIN game_atomic_robo_kid_japanese;
extern struct GAME_MAIN game_avenging_spirit;
extern struct GAME_MAIN game_balloon_bros;
extern struct GAME_MAIN game_batrider;
extern struct GAME_MAIN game_batrider_version_b;
extern struct GAME_MAIN game_batsugun;
extern struct GAME_MAIN game_battle_garegga;
extern struct GAME_MAIN game_battle_shark;
extern struct GAME_MAIN game_bio_ship_paladin;
extern struct GAME_MAIN game_blood_bros;
extern struct GAME_MAIN game_bobble_bobble;
extern struct GAME_MAIN game_bomb_jack_twin;
extern struct GAME_MAIN game_bonze_adventure;
extern struct GAME_MAIN game_bubble_bobble;
extern struct GAME_MAIN game_bubble_bobble_2;
extern struct GAME_MAIN game_bubble_bobble_romstar;
extern struct GAME_MAIN game_bubble_memories;
extern struct GAME_MAIN game_bubble_symphony;
extern struct GAME_MAIN game_cabal;
extern struct GAME_MAIN game_cachat;
extern struct GAME_MAIN game_cadash;
extern struct GAME_MAIN game_cadash_french;
extern struct GAME_MAIN game_cadash_italian;
extern struct GAME_MAIN game_cadash_japanese;
extern struct GAME_MAIN game_camel_try;
extern struct GAME_MAIN game_camel_try_alt;
extern struct GAME_MAIN game_chack_n_pop;
extern struct GAME_MAIN game_champion_wrestler;
extern struct GAME_MAIN game_chase_hq;
extern struct GAME_MAIN game_chase_hq_2_sci;
extern struct GAME_MAIN game_chase_hq_2_sci_alt;
extern struct GAME_MAIN game_chase_hq_japanese;
extern struct GAME_MAIN game_chimera_beast;
extern struct GAME_MAIN game_chuka_taisen;
extern struct GAME_MAIN game_cleopatras_fortune;
extern struct GAME_MAIN game_combatribes;
extern struct GAME_MAIN game_continental_circus;
extern struct GAME_MAIN game_continental_circus_alt;
extern struct GAME_MAIN game_crazy_climber_2;
extern struct GAME_MAIN game_crime_city;
extern struct GAME_MAIN game_cybattler;
extern struct GAME_MAIN game_daisenpu;
extern struct GAME_MAIN game_darius;
extern struct GAME_MAIN game_darius_2;
extern struct GAME_MAIN game_darius_2_dual;
extern struct GAME_MAIN game_darius_alt;
extern struct GAME_MAIN game_darius_extra;
extern struct GAME_MAIN game_darius_gaiden;
extern struct GAME_MAIN game_darius_gaiden_extra;
extern struct GAME_MAIN game_dead_connection;
extern struct GAME_MAIN game_demons_world;
extern struct GAME_MAIN game_dino_rex;
extern struct GAME_MAIN game_dogyuun;
extern struct GAME_MAIN game_don_doko_don;
extern struct GAME_MAIN game_double_dragon_3;
extern struct GAME_MAIN game_dr_toppel_tankentai;
extern struct GAME_MAIN game_drift_out;
extern struct GAME_MAIN game_drive_out;
extern struct GAME_MAIN game_dynamite_league;
extern struct GAME_MAIN game_earth_defence_force;
extern struct GAME_MAIN game_earth_joker;
extern struct GAME_MAIN game_elevator_action_2;
extern struct GAME_MAIN game_ensoniq_test;
extern struct GAME_MAIN game_esprade;
extern struct GAME_MAIN game_euro_champ_92;
extern struct GAME_MAIN game_extermination;
extern struct GAME_MAIN game_exzisus;
extern struct GAME_MAIN game_f3_demo_by_antiriad;
extern struct GAME_MAIN game_fairy_land_story;
extern struct GAME_MAIN game_feveron;
extern struct GAME_MAIN game_fighting_hawk;
extern struct GAME_MAIN game_final_blow;
extern struct GAME_MAIN game_fire_shark;
extern struct GAME_MAIN game_fix_eight;
extern struct GAME_MAIN game_football_champ;
extern struct GAME_MAIN game_full_throttle;
extern struct GAME_MAIN game_galmedes;
extern struct GAME_MAIN game_gekirindan;
extern struct GAME_MAIN game_ghox;
extern struct GAME_MAIN game_grand_cross_pinball;
extern struct GAME_MAIN game_grid_seeker;
extern struct GAME_MAIN game_grind_stormer;
extern struct GAME_MAIN game_growl;
extern struct GAME_MAIN game_gun_frontier;
extern struct GAME_MAIN game_gun_lock;
extern struct GAME_MAIN game_hacha_mecha_fighter;
extern struct GAME_MAIN game_hachoo;
extern struct GAME_MAIN game_hat_trick_hero;
extern struct GAME_MAIN game_hat_trick_hero_95;
extern struct GAME_MAIN game_heavy_unit;
extern struct GAME_MAIN game_hell_fire;
extern struct GAME_MAIN game_hit_the_ice;
extern struct GAME_MAIN game_iga_ninjyutsuden;
extern struct GAME_MAIN game_insector_x;
extern struct GAME_MAIN game_international_cup_94;
extern struct GAME_MAIN game_jigoku_meguri;
extern struct GAME_MAIN game_jumping_islands;
extern struct GAME_MAIN game_kageki;
extern struct GAME_MAIN game_kaiser_knuckle;
extern struct GAME_MAIN game_kaiser_knuckle_alt;
extern struct GAME_MAIN game_kick_and_run;
extern struct GAME_MAIN game_kick_off;
extern struct GAME_MAIN game_kiki_kai_kai;
extern struct GAME_MAIN game_knight_boy;
extern struct GAME_MAIN game_knuckle_bash;
extern struct GAME_MAIN game_koshien;
extern struct GAME_MAIN game_kuri_kinton;
extern struct GAME_MAIN game_kuri_kinton_alt;
extern struct GAME_MAIN game_kyukyoku_tiger_2;
extern struct GAME_MAIN game_land_maker;
extern struct GAME_MAIN game_legend_of_makai;
extern struct GAME_MAIN game_light_bringer;
extern struct GAME_MAIN game_liquid_kids;
extern struct GAME_MAIN game_macross_2;
extern struct GAME_MAIN game_mahjong_quest;
extern struct GAME_MAIN game_mahou_daisakusen;
extern struct GAME_MAIN game_majestic_twelve;
extern struct GAME_MAIN game_makai_densetsu;
extern struct GAME_MAIN game_master_of_weapons;
extern struct GAME_MAIN game_maze_of_flott;
extern struct GAME_MAIN game_mega_blast;
extern struct GAME_MAIN game_meta_fox;
extern struct GAME_MAIN game_metal_black;
extern struct GAME_MAIN game_metal_black_japanese;
extern struct GAME_MAIN game_mustang;
extern struct GAME_MAIN game_mutant_night;
extern struct GAME_MAIN game_night_striker;
extern struct GAME_MAIN game_ninja_gaiden;
extern struct GAME_MAIN game_ninja_kid_2;
extern struct GAME_MAIN game_ninja_kids;
extern struct GAME_MAIN game_ninja_warriors;
extern struct GAME_MAIN game_omega_fighter;
extern struct GAME_MAIN game_omega_fighter_japanese;
extern struct GAME_MAIN game_operation_thunderbolt;
extern struct GAME_MAIN game_operation_wolf;
extern struct GAME_MAIN game_operation_wolf_3;
extern struct GAME_MAIN game_operation_wolf_bootleg;
extern struct GAME_MAIN game_outzone;
extern struct GAME_MAIN game_p47_american;
extern struct GAME_MAIN game_p47_japanese;
extern struct GAME_MAIN game_palamedes;
extern struct GAME_MAIN game_peek_a_boo;
extern struct GAME_MAIN game_phantasm;
extern struct GAME_MAIN game_pipi_and_bibi;
extern struct GAME_MAIN game_plgirls;
extern struct GAME_MAIN game_plgirls2;
extern struct GAME_MAIN game_plotting;
extern struct GAME_MAIN game_plump_pop;
extern struct GAME_MAIN game_plus_alpha;
extern struct GAME_MAIN game_pop_n_pop;
extern struct GAME_MAIN game_prime_time_fighters;
extern struct GAME_MAIN game_psychic_force;
extern struct GAME_MAIN game_puchi_carat;
extern struct GAME_MAIN game_pulirula;
extern struct GAME_MAIN game_puzzle_bobble_2;
extern struct GAME_MAIN game_puzzle_bobble_2x;
extern struct GAME_MAIN game_puzzle_bobble_3;
extern struct GAME_MAIN game_puzzle_bobble_4;
extern struct GAME_MAIN game_puzzle_bobble_b_system;
extern struct GAME_MAIN game_puzznic;
extern struct GAME_MAIN game_quiz_chikyu_bouei_gun;
extern struct GAME_MAIN game_quiz_crayon_shinchan;
extern struct GAME_MAIN game_quiz_crayon_shinchan_2;
extern struct GAME_MAIN game_quiz_hq;
extern struct GAME_MAIN game_quiz_jinsei_gekijoh;
extern struct GAME_MAIN game_quiz_sekai_wa_show_by_shobai;
extern struct GAME_MAIN game_quiz_torimonochou;
extern struct GAME_MAIN game_rad_action;
extern struct GAME_MAIN game_raimais;
extern struct GAME_MAIN game_rainbow_islands;
extern struct GAME_MAIN game_rainbow_islands_alt;
extern struct GAME_MAIN game_rainbow_islands_extra;
extern struct GAME_MAIN game_rally_bike;
extern struct GAME_MAIN game_rambo_3;
extern struct GAME_MAIN game_rambo_3_alternate;
extern struct GAME_MAIN game_rastan;
extern struct GAME_MAIN game_rastan_american;
extern struct GAME_MAIN game_rastan_american_alt;
extern struct GAME_MAIN game_rastan_saga;
extern struct GAME_MAIN game_rastan_saga_2;
extern struct GAME_MAIN game_rastan_saga_2_alt;
extern struct GAME_MAIN game_record_breaker;
extern struct GAME_MAIN game_record_breaker_alt;
extern struct GAME_MAIN game_riding_fight;
extern struct GAME_MAIN game_ring_rage;
extern struct GAME_MAIN game_rodland;
extern struct GAME_MAIN game_rodland_japanese;
extern struct GAME_MAIN game_saint_dragon;
extern struct GAME_MAIN game_salamander_2;
extern struct GAME_MAIN game_same_same_same;
extern struct GAME_MAIN game_shingen;
extern struct GAME_MAIN game_shippu_mahou_daisakusen;
extern struct GAME_MAIN game_silent_dragon;
extern struct GAME_MAIN game_snow_bros;
extern struct GAME_MAIN game_snow_bros_2;
extern struct GAME_MAIN game_snow_bros_alt;
extern struct GAME_MAIN game_snow_bros_alt_2;
extern struct GAME_MAIN game_snow_bros_japanese;
extern struct GAME_MAIN game_soldam;
extern struct GAME_MAIN game_solitary_fighter;
extern struct GAME_MAIN game_space_gun;
extern struct GAME_MAIN game_space_invaders_95;
extern struct GAME_MAIN game_space_invaders_dx;
extern struct GAME_MAIN game_strahl;
extern struct GAME_MAIN game_super_bobble_bobble;
extern struct GAME_MAIN game_super_chase;
extern struct GAME_MAIN game_super_cup_final;
extern struct GAME_MAIN game_super_space_invaders_91;
extern struct GAME_MAIN game_superman;
extern struct GAME_MAIN game_syvalion;
extern struct GAME_MAIN game_taito_cup_final;
extern struct GAME_MAIN game_taito_sega_tetris;
extern struct GAME_MAIN game_task_force_harrier;
extern struct GAME_MAIN game_tatsujin_2;
extern struct GAME_MAIN game_tecmo_knight;
extern struct GAME_MAIN game_teki_paki;
extern struct GAME_MAIN game_terra_cresta;
extern struct GAME_MAIN game_terra_force;
extern struct GAME_MAIN game_tetris_2_plus;
extern struct GAME_MAIN game_the_lord_of_king;
extern struct GAME_MAIN game_the_nz_story;
extern struct GAME_MAIN game_the_nz_story_bootleg;
extern struct GAME_MAIN game_the_nz_story_extra;
extern struct GAME_MAIN game_thunder_dragon;
extern struct GAME_MAIN game_thunder_dragon_bl;
extern struct GAME_MAIN game_thunder_fox;
extern struct GAME_MAIN game_toki;
extern struct GAME_MAIN game_top_landing;
extern struct GAME_MAIN game_top_ranking_stars;
extern struct GAME_MAIN game_top_speed;
extern struct GAME_MAIN game_truxton;
extern struct GAME_MAIN game_twin_eagle;
extern struct GAME_MAIN game_twin_qix;
extern struct GAME_MAIN game_ufo_robo_dangar;
extern struct GAME_MAIN game_under_fire;
extern struct GAME_MAIN game_uo_poko;
extern struct GAME_MAIN game_us_classic_golf;
extern struct GAME_MAIN game_v_five;
extern struct GAME_MAIN game_vimana;
extern struct GAME_MAIN game_vimana_alt;
extern struct GAME_MAIN game_violence_fight;
extern struct GAME_MAIN game_volfied;
extern struct GAME_MAIN game_warrior_blade;
extern struct GAME_MAIN game_west_story;
extern struct GAME_MAIN game_whoopee;
extern struct GAME_MAIN game_winter_bobble;
extern struct GAME_MAIN game_world_grand_prix;
extern struct GAME_MAIN game_world_grand_prix_japanese;
extern struct GAME_MAIN game_wrestle_fest;
extern struct GAME_MAIN game_wwf_super_stars;
extern struct GAME_MAIN game_yuyu_no_quiz_de_gogo;
extern struct GAME_MAIN game_zero_wing;
extern struct GAME_MAIN game_zero_zone;
extern struct GAME_MAIN game_zing_zing_zip;

struct GAME_MAIN *game_list[] =
{
   &game_64th_street,
   &game_64th_street_japanese,
   &game_air_inferno,
   &game_american_horseshoes,
   &game_aqua_jack,
   &game_arabian_magic,
   &game_ark_area,
   &game_arkanoid_2_american,
   &game_arkanoid_2_japanese,
   &game_arkanoid_2_rev_of_doh,
   &game_arkanoid_returns,
   &game_armed_formation,
   &game_ashura_blaster,
   &game_ashura_blaster_us,
   &game_astyanax,
   &game_asuka_and_asuka,
   &game_atomic_robo_kid,
   &game_atomic_robo_kid_japanese,
   &game_avenging_spirit,
   &game_balloon_bros,
   &game_batrider,
   &game_batrider_version_b,
   &game_batsugun,
   &game_battle_garegga,
   &game_battle_shark,
   &game_bio_ship_paladin,
   &game_blood_bros,
   &game_bobble_bobble,
   &game_bomb_jack_twin,
   &game_bonze_adventure,
   &game_bubble_bobble,
   &game_bubble_bobble_2,
   &game_bubble_bobble_romstar,
   &game_bubble_memories,
   &game_bubble_symphony,
   &game_cabal,
   &game_cachat,
   &game_cadash,
   &game_cadash_french,
   &game_cadash_italian,
   &game_cadash_japanese,
   &game_camel_try,
   &game_camel_try_alt,
   &game_chack_n_pop,
   &game_champion_wrestler,
   &game_chase_hq,
   &game_chase_hq_2_sci,
   &game_chase_hq_2_sci_alt,
   &game_chase_hq_japanese,
   &game_chimera_beast,
   &game_chuka_taisen,
   &game_cleopatras_fortune,
   &game_combatribes,
   &game_continental_circus,
   &game_continental_circus_alt,
   &game_crazy_climber_2,
   &game_crime_city,
   &game_cybattler,
   &game_daisenpu,
   &game_darius,
   &game_darius_2,
   &game_darius_2_dual,
   &game_darius_alt,
   &game_darius_extra,
   &game_darius_gaiden,
   &game_darius_gaiden_extra,
   &game_dead_connection,
   &game_demons_world,
   &game_dino_rex,
   &game_dogyuun,
   &game_don_doko_don,
   &game_double_dragon_3,
   &game_dr_toppel_tankentai,
   &game_drift_out,
   &game_drive_out,
   &game_dynamite_league,
   &game_earth_defence_force,
   &game_earth_joker,
   &game_elevator_action_2,
//   &game_ensoniq_test,
   &game_esprade,
   &game_euro_champ_92,
   &game_extermination,
   &game_exzisus,
   &game_f3_demo_by_antiriad,
   &game_fairy_land_story,
   &game_feveron,
   &game_fighting_hawk,
   &game_final_blow,
   &game_fire_shark,
   &game_fix_eight,
   &game_football_champ,
   &game_full_throttle,
   &game_galmedes,
   &game_gekirindan,
   &game_ghox,
   &game_grand_cross_pinball,
   &game_grid_seeker,
   &game_grind_stormer,
   &game_growl,
   &game_gun_frontier,
   &game_gun_lock,
   &game_hacha_mecha_fighter,
   &game_hachoo,
   &game_hat_trick_hero,
   &game_hat_trick_hero_95,
   &game_heavy_unit,
   &game_hell_fire,
   &game_hit_the_ice,
   &game_iga_ninjyutsuden,
   &game_insector_x,
//   &game_international_cup_94,
   &game_jigoku_meguri,
   &game_jumping_islands,
   &game_kageki,
   &game_kaiser_knuckle,
   &game_kaiser_knuckle_alt,
   &game_kick_and_run,
   &game_kick_off,
   &game_kiki_kai_kai,
   &game_knight_boy,
   &game_knuckle_bash,
   &game_koshien,
   &game_kuri_kinton,
   &game_kuri_kinton_alt,
   &game_kyukyoku_tiger_2,
   &game_land_maker,
   &game_legend_of_makai,
   &game_light_bringer,
   &game_liquid_kids,
   &game_macross_2,
   &game_mahjong_quest,
   &game_mahou_daisakusen,
   &game_majestic_twelve,
   &game_makai_densetsu,
   &game_master_of_weapons,
   &game_maze_of_flott,
   &game_mega_blast,
   &game_metal_black,
   &game_metal_black_japanese,
   &game_mustang,
   &game_mutant_night,
   &game_night_striker,
   &game_ninja_gaiden,
   &game_ninja_kid_2,
   &game_ninja_kids,
   &game_ninja_warriors,
   &game_omega_fighter,
   &game_omega_fighter_japanese,
   &game_operation_thunderbolt,
   &game_operation_wolf,
//   &game_operation_wolf_3,
   &game_operation_wolf_bootleg,
   &game_outzone,
   &game_p47_american,
   &game_p47_japanese,
   &game_palamedes,
   &game_peek_a_boo,
   &game_phantasm,
   &game_pipi_and_bibi,
   &game_plotting,
   &game_plump_pop,
   &game_plus_alpha,
   &game_pop_n_pop,
   &game_prime_time_fighters,
//   &game_psychic_force,
   &game_puchi_carat,
   &game_pulirula,
   &game_puzzle_bobble_2,
   &game_puzzle_bobble_2x,
   &game_puzzle_bobble_3,
   &game_puzzle_bobble_4,
   &game_puzzle_bobble_b_system,
   &game_puzznic,
   &game_plgirls,
   &game_plgirls2,
   &game_quiz_chikyu_bouei_gun,
   &game_quiz_crayon_shinchan,
   &game_quiz_crayon_shinchan_2,
   &game_quiz_hq,
   &game_quiz_jinsei_gekijoh,
   &game_quiz_sekai_wa_show_by_shobai,
   &game_quiz_torimonochou,
   &game_rad_action,
   &game_raimais,
   &game_rainbow_islands,
   &game_rainbow_islands_alt,
   &game_rainbow_islands_extra,
   &game_rally_bike,
   &game_rambo_3,
   &game_rambo_3_alternate,
   &game_rastan,
   &game_rastan_american,
   &game_rastan_american_alt,
   &game_rastan_saga,
   &game_rastan_saga_2,
   &game_rastan_saga_2_alt,
   &game_record_breaker,
   &game_record_breaker_alt,
   &game_riding_fight,
   &game_ring_rage,
   &game_rodland,
   &game_rodland_japanese,
   &game_saint_dragon,
//   &game_salamander_2,
   &game_same_same_same,
   &game_shingen,
   &game_shippu_mahou_daisakusen,
   &game_silent_dragon,
   &game_snow_bros,
   &game_snow_bros_2,
   &game_snow_bros_alt,
   &game_snow_bros_alt_2,
   &game_snow_bros_japanese,
   &game_soldam,
   &game_solitary_fighter,
   &game_space_gun,
   &game_space_invaders_95,
   &game_space_invaders_dx,
   &game_strahl,
   &game_super_bobble_bobble,
//   &game_super_chase,
   &game_super_cup_final,
   &game_super_space_invaders_91,
   &game_superman,
   &game_syvalion,
   &game_taito_cup_final,
   &game_taito_sega_tetris,
   &game_task_force_harrier,
   &game_tatsujin_2,
   &game_tecmo_knight,
   &game_teki_paki,
   &game_terra_cresta,
   &game_terra_force,
   &game_tetris_2_plus,
   &game_the_lord_of_king,
   &game_the_nz_story,
   &game_the_nz_story_bootleg,
   &game_the_nz_story_extra,
   &game_thunder_dragon,
   &game_thunder_dragon_bl,
   &game_thunder_fox,
   &game_toki,
   &game_top_landing,
   &game_top_ranking_stars,
   &game_top_speed,
   &game_truxton,
   &game_twin_qix,
//   &game_ufo_robo_dangar,
   &game_under_fire,
   &game_uo_poko,
   &game_v_five,
   &game_vimana,
   &game_vimana_alt,
   &game_violence_fight,
   &game_volfied,
   &game_warrior_blade,
   &game_west_story,
   &game_whoopee,
   &game_winter_bobble,
   &game_world_grand_prix,
   &game_world_grand_prix_japanese,
   &game_wrestle_fest,
   &game_wwf_super_stars,
   &game_yuyu_no_quiz_de_gogo,
   &game_zero_wing,
   &game_zero_zone,

#ifdef HAVE_6502
#ifdef BGAMES
   &game_meta_fox,
   &game_twin_eagle,
   &game_us_classic_golf,
   &game_zing_zing_zip,
#endif
#endif
};

void init_game_list(void)
{
   GAME_MAIN *swap;
   int i,j;

   /*

   count the games

   */

   game_count = sizeof(game_list) / sizeof(GAME_MAIN *);

   /*

   sort game_list by long_name (bubble sort)

   */

   for(i = game_count-1; i > 0; i --){

      for(j = 1; j <= i; j ++){

         if( stricmp(game_list[j-1]->long_name, game_list[j]->long_name) > 0){

            swap           = game_list[j-1];
            game_list[j-1] = game_list[j];
            game_list[j]   = swap;

         }

      }

   }

   /*

   no game is loaded

   */

   current_game = NULL;

}

char *game_company_name(UBYTE company_id)
{
   return company_name[company_id];
}

