/******************************************************************************/
/*                                                                            */
/*                 tc0005rot: TAITO ROTATION LAYER (F2-SYSTEM)                */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

typedef struct TC0005ROT			// Information about 1 chip
{
   UBYTE *RAM;					// Chip RAM address
   UBYTE *RAM_SCR;				// Scroll RAM address
   UBYTE *GFX_ROT;				// GFX BG0
} TC0005ROT;

struct TC0005ROT tc0005rot;

void init_tc0005rot(int mode);

void tc0005rot_bg0_ww(ULONG address, UWORD data);

void tc0005rot_refresh_buffer(void);

void tc0005rot_draw_rot(int col_ofs);
void tc0005rot_draw_rot_r270(int col_ofs);

//void RotateF2SystemBG0(fixed f1x, fixed f1y, fixed f1xd,fixed f1yd,fixed f2xd,fixed f2yd);
