/******************************************************************************/
/*                                                                            */
/*   tc0140syt: TAITO MAIN TO SOUND CPU COMMUNICATION (68000-Z80; Z80-Z80)    */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

void tc0140syt_reset(void);

UBYTE tc0140syt_get_port01(void);
UBYTE tc0140syt_get_port23(void);

UBYTE tc0140syt_want_nmi(void);

// 68000 Main
// ----------

UBYTE tc0140syt_read_main_68k(ULONG offset);
void tc0140syt_write_main_68k(ULONG offset, UBYTE data);

// Z80 Main
// --------

UBYTE tc0140syt_read_main_z80(UWORD offset);
void tc0140syt_write_main_z80(UWORD offset, UBYTE data);

// Z80 Sub
// -------

UBYTE tc0140syt_read_sub_z80(UWORD offset);
void tc0140syt_write_sub_z80(UWORD offset, UBYTE data);

