/*
 *  RAINE MEMORY MANAGEMENT - Very Primitive so far... :)
 */

#include "deftypes.h"

// ---
// Memory leak tracking, from Mirko Buffoni !!
// ---

#ifdef MEMORY_DEBUG

#define malloc(A) mymalloc(A, __FILE__, __LINE__)
#define realloc(A,B) myrealloc(A, B, __FILE__, __LINE__)
#define free(A) myfree(A, __FILE__, __LINE__)
#define InitPurify mbInitPurify
#define DonePurify mbDonePurify

void mbInitPurify(void);
void mbDonePurify(void);
void *mymalloc(ULONG size, char *fname, ULONG fline);
void *myrealloc(void *ptr, ULONG size, char *fname, ULONG fline);
void myfree(void *ptr, char *fname, ULONG fline);

#endif

// ---

UBYTE *AllocateMem(ULONG size);

void FreeMem(UBYTE *mem);

void ResetMemoryPool(void);

void FreeMemoryPool(void);

