/******************************************************************************/
/*                                                                            */
/*                   SOME CUSTOM ASM VIDEO SUPPORT ROUTINES                   */
/*                                                                            */
/******************************************************************************/

#include "raine.h"

ULONG SourceSeg;
ULONG DestSeg;
ULONG SourceStart;
ULONG DestStart;
ULONG BlitWidth;
ULONG BlitHeight;
ULONG SourceAdd;
ULONG DestAdd;

void fast_blit_movsl(void);
void fast_blit_movl(void);
void fast_blit_movq(void);

// Update only changed palette entries, and vsync if enabled
// even if it wasn't needed

void fast_palette_update(PALETTE p, PALETTE p2, int vsync);

// Update only changed palette entries, and only vsync if
// a changed entry exists

void fast_palette_update_vsync_check(PALETTE p, PALETTE p2);
