/******************************************************************************/
/*                                                                            */
/*                         RAINE 16x16 TILE DRAWING                           */
/*                                                                            */
/******************************************************************************/

/*

Mapped
Transparent Mapped
Direct-Mapped
Transparent Direct-Mapped

*/

void init_spr16x16asm(void);

// 16x16 mapped sprites

void Draw16x16_Mapped(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

// 16x16 mapped transparent sprites

void Draw16x16_Trans_Mapped(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

void init_spr16x16asm_16(void);

// 16x16 mapped sprites

void Draw16x16_Mapped_16(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_16_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_16_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_16_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

// 16x16 mapped transparent sprites

void Draw16x16_Trans_Mapped_16(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_16_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_16_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_16_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

void init_spr16x16asm_24(void);

// 16x16 mapped sprites

void Draw16x16_Mapped_24(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_24_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_24_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_24_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

// 16x16 mapped transparent sprites

void Draw16x16_Trans_Mapped_24(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_24_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_24_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_24_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

void init_spr16x16asm_32(void);

// 16x16 mapped sprites

void Draw16x16_Mapped_32(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_32_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_32_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_32_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

// 16x16 mapped transparent sprites

void Draw16x16_Trans_Mapped_32(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_32_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_32_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_32_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

// 16x16 sprites

void Draw16x16(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw16x16_FlipX(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw16x16_FlipY(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw16x16_FlipXY(UBYTE *SPR, int x, int y, UBYTE cmap);

// 16x16 transparent sprites

void Draw16x16_Trans(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw16x16_Trans_FlipX(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw16x16_Trans_FlipY(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw16x16_Trans_FlipXY(UBYTE *SPR, int x, int y, UBYTE cmap);
