
extern struct INPUT_INFO f3_system_inputs[];
extern struct INPUT_INFO f3_system_inputs_6_button[];
extern struct INPUT_INFO f3_system_inputs_4_player[];

void AddF3MemoryMap(ULONG romsize);

int f3_bg0_id;
int f3_bg1_id;
int f3_bg2_id;
int f3_bg3_id;

int f3_bg5_id;
int f3_bg6_id;

// I/O controller type

#define F3_IOC_2P_3BUTTON	(0x0000)
#define F3_IOC_2P_6BUTTON	(0x0001)
#define F3_IOC_4P_3BUTTON	(0x0002)

#define F3_IOC_TRACKBALL	(0x0010)

void init_f3_system_ioc(ULONG type);

void IntF3System(void);
void ExecuteF3SystemFrame(void);
void ExecuteF3SystemFrame_NoInt5(void);

void F3SysEEPROMAccessMode1(UBYTE data);
void F3SysEEPROMAccessMode1B(UBYTE data);
void F3SysEEPROMAccessMode2(UBYTE data);

UBYTE *F3ModData;

ULONG ddd[32];
