/******************************************************************************/
/*                                                                            */
/*        SETA X1-001A/002A/006/004/003: SETA & TAITO VIDEO HARDWARE          */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

typedef struct SETA_X1				// Information about 1 chip
{
   UBYTE *RAM_A;				// VIDEO RAM A
   UBYTE *RAM_B;				// VIDEO RAM B
   UBYTE *GFX;					// GFX TILES
   UBYTE *MASK;					// GFX MASK DATA
   ULONG tile_mask;				// Last tile number
   ULONG bmp_x,bmp_y;				// Game screen offset (32,32)
   ULONG bmp_w,bmp_h;				// Game screen size (356,240)
   ULONG scr_x,scr_y;				// Scroll offset add (0,0)
} SETA_X1;

struct SETA_X1 seta_x1;

void render_seta_x1_68000(void);

void render_seta_x1_z80(void);
