/******************************************************************************/
/*                                                                            */
/*                              R-GUI: RAINE GUI                              */
/*                                                                            */
/******************************************************************************/

#ifndef __rguidefs__
#define __rguidefs__

//#define TEST_WINGUI

#include "raine.h"

int raine_gfx_mode_select(void);

int raine_alert(char *title, char *s1, char *s2, char *s3, char *b1, char *b2, int c1, int c2);

char *gfx_card_name(ULONG index);

void dialog_oxygen(void);

int raine_do_dialog(DIALOG *dialog, int focus_obj);

void mouse_on_real_screen(void);

void mouse_on_buffer_screen(void);

// this one in rfsel.c

int raine_file_select(char *message, char *path, char *ext);

#ifdef TEST_WINGUI

typedef struct WIN_DATA
{
   BITMAP *window;
   ULONG  back_x;
   ULONG  back_y;
   ULONG  back_w;
   ULONG  back_h;
} WIN_DATA;

ULONG win_count;

WIN_DATA win_list[8];

int raine_window_dialog(DIALOG *dialog, int focus_obj);

int rgui_mouse_x(void);
int rgui_mouse_y(void);
int rgui_mouse_b(void);

#else

#define rgui_mouse_x	gui_mouse_x
#define rgui_mouse_y	gui_mouse_y
#define rgui_mouse_b	gui_mouse_b

#define raine_window_dialog	raine_do_dialog

#endif

#endif
