/******************************************************************************/
/*                                                                            */
/*                     SOME EXTRA STUFF FOR HARDWARE YM3812                   */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

// Hardware Output
// ---------------

void start_raine_ym3812(void);
void stop_raine_ym3812(void);

void pause_raine_ym3812(void);
void unpause_raine_ym3812(void);

void osd_ym3812_control(UBYTE data);
void osd_ym3812_write(UBYTE data);

// YM3812 Handler
// --------------

UBYTE YM3812ReadZ80(UWORD offset);
void YM3812WriteZ80(UWORD offset, UBYTE data);

// YM3526 Handler
// --------------

#define YM3526ReadZ80  YM3812ReadZ80
#define YM3526WriteZ80 YM3812WriteZ80
