/******************************************************************************/
/*                                                                            */
/*                          RAINE 8x8 TILE DRAWING                            */
/*                                                                            */
/******************************************************************************/

/*

Mapped
Transparent Mapped
Direct-Mapped
Transparent Direct-Mapped

*/

void init_spr8x8asm(void);

// 8x8 mapped sprites

void Draw8x8_Mapped(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

// 8x8 mapped transparent sprites

void Draw8x8_Trans_Mapped(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

void init_spr8x8asm_16(void);

// 8x8 mapped sprites

void Draw8x8_Mapped_16(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_16_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_16_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_16_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

// 8x8 mapped transparent sprites

void Draw8x8_Trans_Mapped_16(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_16_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_16_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_16_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

void init_spr8x8asm_24(void);

// 8x8 mapped sprites

void Draw8x8_Mapped_24(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_24_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_24_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_24_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

// 8x8 mapped transparent sprites

void Draw8x8_Trans_Mapped_24(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_24_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_24_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_24_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

void init_spr8x8asm_32(void);

// 8x8 mapped sprites

void Draw8x8_Mapped_32(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_32_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_32_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Mapped_32_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

// 8x8 mapped transparent sprites

void Draw8x8_Trans_Mapped_32(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_32_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_32_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw8x8_Trans_Mapped_32_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

// 8x8 sprites

void Draw8x8(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw8x8_FlipX(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw8x8_FlipY(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw8x8_FlipXY(UBYTE *SPR, int x, int y, UBYTE cmap);

// 8x8 transparent sprites

void Draw8x8_Trans(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw8x8_Trans_FlipX(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw8x8_Trans_FlipY(UBYTE *SPR, int x, int y, UBYTE cmap);
void Draw8x8_Trans_FlipXY(UBYTE *SPR, int x, int y, UBYTE cmap);
