/******************************************************************************/
/*                                                                            */
/*                          RAINE 16x8 TILE ZOOMING                           */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

// These ones can zoom from x/y = [0..16] (ie. max size is normal: 16x8)

void init_16x8_zoom(void);
UBYTE *make_16x8_zoom_ofs_type1(void);
UBYTE *make_16x8_zoom_ofs_type1z(void);
UBYTE *make_16x8_zoom_ofs_type1zz(void);

void Draw16x8_Trans_Mapped_ZoomXY       (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x8_Trans_Mapped_ZoomXY_FlipY (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x8_Trans_Mapped_ZoomXY_FlipX (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x8_Trans_Mapped_ZoomXY_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);

void Draw16x8_Mapped_ZoomXY       (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x8_Mapped_ZoomXY_FlipY (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x8_Mapped_ZoomXY_FlipX (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x8_Mapped_ZoomXY_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
